/* LCM type definition class file
 * This file was automatically generated by lcm-gen
 * DO NOT MODIFY BY HAND!!!!
 */

package gps_imu_lcm;
 
import java.io.*;
import java.util.*;
import lcm.lcm.*;
 
public final class imu_t implements lcm.lcm.LCMEncodable
{
    public double timestamp;
    public double theta_z;
    public double theta_y;
    public double theta_x;
    public double mag_x;
    public double mag_y;
    public double mag_z;
    public double acc_x;
    public double acc_y;
    public double acc_z;
    public double theta_x_d;
    public double theta_y_d;
    public double theta_z_d;
 
    public imu_t()
    {
    }
 
    public static final long LCM_FINGERPRINT;
    public static final long LCM_FINGERPRINT_BASE = 0x90799bb35473a707L;
 
    static {
        LCM_FINGERPRINT = _hashRecursive(new ArrayList<Class<?>>());
    }
 
    public static long _hashRecursive(ArrayList<Class<?>> classes)
    {
        if (classes.contains(gps_imu_lcm.imu_t.class))
            return 0L;
 
        classes.add(gps_imu_lcm.imu_t.class);
        long hash = LCM_FINGERPRINT_BASE
            ;
        classes.remove(classes.size() - 1);
        return (hash<<1) + ((hash>>63)&1);
    }
 
    public void encode(DataOutput outs) throws IOException
    {
        outs.writeLong(LCM_FINGERPRINT);
        _encodeRecursive(outs);
    }
 
    public void _encodeRecursive(DataOutput outs) throws IOException
    {
        outs.writeDouble(this.timestamp); 
 
        outs.writeDouble(this.theta_z); 
 
        outs.writeDouble(this.theta_y); 
 
        outs.writeDouble(this.theta_x); 
 
        outs.writeDouble(this.mag_x); 
 
        outs.writeDouble(this.mag_y); 
 
        outs.writeDouble(this.mag_z); 
 
        outs.writeDouble(this.acc_x); 
 
        outs.writeDouble(this.acc_y); 
 
        outs.writeDouble(this.acc_z); 
 
        outs.writeDouble(this.theta_x_d); 
 
        outs.writeDouble(this.theta_y_d); 
 
        outs.writeDouble(this.theta_z_d); 
 
    }
 
    public imu_t(byte[] data) throws IOException
    {
        this(new LCMDataInputStream(data));
    }
 
    public imu_t(DataInput ins) throws IOException
    {
        if (ins.readLong() != LCM_FINGERPRINT)
            throw new IOException("LCM Decode error: bad fingerprint");
 
        _decodeRecursive(ins);
    }
 
    public static gps_imu_lcm.imu_t _decodeRecursiveFactory(DataInput ins) throws IOException
    {
        gps_imu_lcm.imu_t o = new gps_imu_lcm.imu_t();
        o._decodeRecursive(ins);
        return o;
    }
 
    public void _decodeRecursive(DataInput ins) throws IOException
    {
        this.timestamp = ins.readDouble();
 
        this.theta_z = ins.readDouble();
 
        this.theta_y = ins.readDouble();
 
        this.theta_x = ins.readDouble();
 
        this.mag_x = ins.readDouble();
 
        this.mag_y = ins.readDouble();
 
        this.mag_z = ins.readDouble();
 
        this.acc_x = ins.readDouble();
 
        this.acc_y = ins.readDouble();
 
        this.acc_z = ins.readDouble();
 
        this.theta_x_d = ins.readDouble();
 
        this.theta_y_d = ins.readDouble();
 
        this.theta_z_d = ins.readDouble();
 
    }
 
    public gps_imu_lcm.imu_t copy()
    {
        gps_imu_lcm.imu_t outobj = new gps_imu_lcm.imu_t();
        outobj.timestamp = this.timestamp;
 
        outobj.theta_z = this.theta_z;
 
        outobj.theta_y = this.theta_y;
 
        outobj.theta_x = this.theta_x;
 
        outobj.mag_x = this.mag_x;
 
        outobj.mag_y = this.mag_y;
 
        outobj.mag_z = this.mag_z;
 
        outobj.acc_x = this.acc_x;
 
        outobj.acc_y = this.acc_y;
 
        outobj.acc_z = this.acc_z;
 
        outobj.theta_x_d = this.theta_x_d;
 
        outobj.theta_y_d = this.theta_y_d;
 
        outobj.theta_z_d = this.theta_z_d;
 
        return outobj;
    }
 
}

